package cologne.eck.all_peas.gui;

import java.awt.Color;

import javax.swing.BorderFactory;
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;


public class PeaBorderFactory {
	


	/**
	 * Create the default pea border, a CounpoundBorder with three borders
	 * (dark, bright, peaColor) for frames and dialogs. 
	 * 
	 * @param withMenu	true, if the border is used for a window with menu 
	 * 					(top and left borders are thinner then)
	 * @return			the CompoundBorder with three borders
	 */
	public static CompoundBorder createBorder(boolean withMenu) {
		
		CompoundBorder threeBorder;
		
		if (withMenu == true) {
			
			Border compoundBorder = BorderFactory.createCompoundBorder(
					BorderFactory.createMatteBorder(1,1,1,1, new Color(160, 178, 162)),
					BorderFactory.createMatteBorder(2,2,4,4, new Color(242, 255, 243)) 
							);
			threeBorder = BorderFactory.createCompoundBorder(
					compoundBorder,
					BorderFactory.createMatteBorder(2,2,5,5, PswDialogView.getPeaColor())
							);
		} else {
			Border compoundBorder = BorderFactory.createCompoundBorder(
					BorderFactory.createMatteBorder(1,1,1,1, new Color(160, 178, 162)),
					BorderFactory.createMatteBorder(4,4,4,4, new Color(242, 255, 243)) 
							);
			threeBorder = BorderFactory.createCompoundBorder(
					compoundBorder,
					BorderFactory.createMatteBorder(5,5,5,5, PswDialogView.getPeaColor())
							);			
		}
		return threeBorder;
	}
}