package cologne.eck.all_peas.gui;

/**
 * This class is currently only used by Image Lock PEA
 */

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collections;

import javax.accessibility.AccessibleContext;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

@SuppressWarnings("serial")
public class SingleFileSelectionDialog extends JDialog implements ActionListener {
	
	private JPanel filePanel;
	private static String fileName;
	private ButtonGroup group = null;

	public SingleFileSelectionDialog (Window window, Point loc, String areaText, ArrayList <String> fileNames) {
		super( window);
		this.setModalityType(JDialog.DEFAULT_MODALITY_TYPE);
		JPanel contentPane = (JPanel) this.getContentPane();
		contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
		
		JPanel textPanel = new JPanel();
		textPanel.setLayout(new BoxLayout(textPanel, BoxLayout.X_AXIS));
		JTextArea textArea = new JTextArea();
		textArea.setText(areaText);
		textPanel.add(textArea);
		textPanel.add(Box.createHorizontalGlue());
		textPanel.setMaximumSize(new Dimension(600,200));
		textPanel.setMinimumSize(new Dimension(200,50));
		contentPane.add(textPanel);

		filePanel = new JPanel();
		filePanel.setLayout(new BoxLayout(filePanel, BoxLayout.Y_AXIS));
		// alphabetical order: 
		Collections.sort(fileNames);
		group = new ButtonGroup();
		int len = fileNames.size();
		for (int i = 0; i < len; i++) {
			JRadioButton rb = new JRadioButton(fileNames.get(i));
			rb.setSelected(true);
			group.add(rb);
			filePanel.add(rb);
		}

		JScrollPane scrollPane = new JScrollPane(filePanel);
		scrollPane.setPreferredSize(new Dimension(400, 200));
		contentPane.add(scrollPane);
		
		JPanel okPanel = new JPanel();
		okPanel.setLayout(new BoxLayout(okPanel, BoxLayout.X_AXIS));
		JButton okButton = new JButton("ok");
		okButton.addActionListener(this);
		okButton.setActionCommand("ok");
		okPanel.add(Box.createHorizontalGlue());
		okPanel.add(okButton);
		contentPane.add(okPanel);
		
		this.pack();
		this.setLocation(loc);
		this.setVisible(true);
	}
	
	@Override
	public void actionPerformed(ActionEvent ape) {

		String command = ape.getActionCommand();
		if (command.equals("ok")) {

//System.out.println("ImageDisplay ok");
			Component[] components = filePanel.getComponents();
			int len = components.length;
			for (int i = 0; i < len;i++) {
				if (components[i] instanceof JRadioButton) {
					if (( (JRadioButton)components[i]).isSelected() == true) {
//System.out.println("ImageDisplay add: " +  ((JCheckBox) components[i]).getText() );						
						fileName =  ((JRadioButton) components[i]).getText();						
					}
				}
			}
//System.out.println("dispose");
			this.dispose();
		}
	}
	
	public static String getSelectedFileName() {
		
		return fileName;
	}
    public AccessibleContext getAccessibleContext() {
        if (accessibleContext == null) {
            accessibleContext = new AccessibleSingleFileSelectionDialog();
        }
        return accessibleContext;
    }

    protected class AccessibleSingleFileSelectionDialog extends AccessibleJDialog {
        //Inherit everything, override nothing.
    }
}
