package cologne.eck.peafactory.control;
/*
 * Peafactory - Production of Password Encryption Archives
 * Copyright (C) 2015  Axel von dem Bruch
 * 
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, 
 * or (at your option) any later version.
 * This library is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * See:  http://www.gnu.org/licenses/gpl-2.0.html
 * You should have received a copy of the GNU General Public License 
 * along with this library.
 */

/**
 * Generation of the file pea, 
 * not used in the pea itself  
 */


import java.io.File;

import cologne.eck.all_peas.files.FileTypePanel;
import cologne.eck.peafactory.crypto.CipherStuff;
import cologne.eck.peafactory.gui.MainView;


public class FileType extends DataType {
	
	private static byte[] fileNamesAsBytes = null;

	@Override
	public void processData( byte[] keyMaterial) {
		
		if (PeaFactory.isBlankPea() == false) {
		
			String[] fileNames = MainView.getFilePanel().getValidFileNames(true);

			FileTypePanel filePanel = MainView.getFilePanel();
			
			// Set the progress for large files or for many files:
			// the values are the same as in EAXMode setProgressValues()
			if (filePanel.getFileComposer().getFileModel().getAllSize() > 16 * 1024 * 1024 
					|| filePanel.getFileComposer().getFileModel().getFileNumber() > 64) {
				filePanel.startProgressTask();
			} 

			CipherStuff.getCipherMode().encryptFiles(fileNames, keyMaterial, false, filePanel.getFileComposer());
			filePanel.closeProgressTask();// close automatically
			
		} else {
			// create directory to contain jar file and start files
			String dirName = JarStuff.getJarFileName().substring(0, (JarStuff.getJarFileName().length() - 4)); // extract ".jar"
			new File(dirName).mkdirs();
		}
	}

	@Override
	public String getDescription() {
		return PeaFactory.getLanguagesBundle().getString("file_description");
	}

	@Override
	public String getTypeName() {
		return "file";
	}

	@Override
	public byte[] getData() {
		return fileNamesAsBytes;
	}

	@Override
	public void setData(byte[] data) {
		fileNamesAsBytes = data;		
	}
}
